## ros-indigo-robot-localization 2.3.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(robot_localization)

find_package(catkin REQUIRED COMPONENTS
  diagnostic_msgs
  diagnostic_updater
  geographic_msgs
  geometry_msgs
  message_filters
  message_generation
  nav_msgs
  roscpp
  roslint
  sensor_msgs
  std_msgs
  tf2
  tf2_geometry_msgs
  tf2_ros)

# Attempt to find Eigen using its own CMake module.
# If that fails, fall back to cmake_modules package.
find_package(Eigen3)
set(EIGEN_PACKAGE EIGEN3)
if(NOT EIGEN3_FOUND)
  find_package(cmake_modules REQUIRED)
  find_package(Eigen REQUIRED)
  set(EIGEN3_INCLUDE_DIRS ${EIGEN_INCLUDE_DIRS})
  set(EIGEN3_LIBRARIES ${EIGEN_LIBRARIES})
  set(EIGEN_PACKAGE Eigen)
endif()

add_definitions(-DEIGEN_NO_DEBUG -DEIGEN_MPL2_ONLY)

roslint_cpp()

###################################
## catkin specific configuration ##
###################################
add_service_files(
  FILES
    SetDatum.srv
    SetPose.srv
)

generate_messages(
  DEPENDENCIES
    geographic_msgs
    geometry_msgs
    std_msgs
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES 
    ekf
    filter_base
    filter_utilities
    navsat_transform
    ros_filter
    ros_filter_utilities
    ukf
  CATKIN_DEPENDS
    cmake_modules
    diagnostic_msgs
    diagnostic_updater
    geographic_msgs
    geometry_msgs
    message_filters
    message_runtime
    nav_msgs
    roscpp
    sensor_msgs
    std_msgs
    tf2
    tf2_geometry_msgs
    tf2_ros
  DEPENDS ${EIGEN_PACKAGE}
)

###########
## Build ##
###########

include_directories(include ${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIRS})

# Library definitions
add_library(filter_utilities src/filter_utilities.cpp)
add_library(filter_base src/filter_base.cpp)
add_library(ekf src/ekf.cpp)
add_library(ukf src/ukf.cpp)
add_library(ros_filter_utilities src/ros_filter_utilities.cpp)
add_library(ros_filter src/ros_filter.cpp)
add_library(navsat_transform src/navsat_transform.cpp)

# Dependencies
add_dependencies(filter_base ${PROJECT_NAME}_gencpp)
add_dependencies(navsat_transform ${PROJECT_NAME}_gencpp)

# Executables
add_executable(ekf_localization_node src/ekf_localization_node.cpp)
add_executable(ukf_localization_node src/ukf_localization_node.cpp)
add_executable(navsat_transform_node src/navsat_transform_node.cpp)

# Linking
target_link_libraries(ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(filter_base filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ekf filter_base ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ukf filter_base ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ros_filter ekf ukf ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(ekf_localization_node ros_filter ${catkin_LIBRARIES})
target_link_libraries(ukf_localization_node ros_filter ${catkin_LIBRARIES})
target_link_libraries(navsat_transform filter_utilities ros_filter_utilities ${catkin_LIBRARIES} ${EIGEN3_LIBRARIES})
target_link_libraries(navsat_transform_node navsat_transform ${catkin_LIBRARIES})

#############
## Install ##
#############

## Mark executables and/or libraries for installation
install(TARGETS
  ekf
  ekf_localization_node
  filter_base
  filter_utilities
  navsat_transform
  navsat_transform_node
  ros_filter
  ros_filter_utilities
  ukf
  ukf_localization_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION})

## Mark cpp header files for installation
install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
  PATTERN ".svn" EXCLUDE)

install(DIRECTORY launch/
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}/launch
  FILES_MATCHING PATTERN "*.launch"
  PATTERN ".svn" EXCLUDE)

install(FILES
  LICENSE
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

#############
## Testing ##
#############

if (CATKIN_ENABLE_TESTING)

  # Not really necessary, but it will cause the build to fail if it's
  # missing, rather than failing once the tests are being executed
  find_package(rosbag REQUIRED)
  find_package(rostest REQUIRED)

  #### FILTER BASE TESTS ####
  catkin_add_gtest(filter_base-test test/test_filter_base.cpp)
  target_link_libraries(filter_base-test filter_base ${catkin_LIBRARIES})

  # This test uses ekf_localization node for convenience.
  add_rostest_gtest(test_filter_base_diagnostics_timestamps
                    test/test_filter_base_diagnostics_timestamps.test
                    test/test_filter_base_diagnostics_timestamps.cpp)
  target_link_libraries(test_filter_base_diagnostics_timestamps ${catkin_LIBRARIES} ${rostest_LIBRARIES})
  add_dependencies(test_filter_base_diagnostics_timestamps ekf_localization_node)

  #### EKF TESTS #####
  add_rostest_gtest(test_ekf
                    test/test_ekf.test
                    test/test_ekf.cpp)
  target_link_libraries(test_ekf ros_filter ekf ${catkin_LIBRARIES} ${rostest_LIBRARIES})


  add_rostest_gtest(test_ekf_localization_node_interfaces
                    test/test_ekf_localization_node_interfaces.test
                    test/test_ekf_localization_node_interfaces.cpp)
  target_link_libraries(test_ekf_localization_node_interfaces ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_node_bag1
                    test/test_ekf_localization_node_bag1.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_node_bag1 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_node_bag2
                    test/test_ekf_localization_node_bag2.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_node_bag2 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ekf_localization_node_bag3
                    test/test_ekf_localization_node_bag3.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ekf_localization_node_bag3 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  #### UKF TESTS #####
  add_rostest_gtest(test_ukf
                    test/test_ukf.test
                    test/test_ukf.cpp)
  target_link_libraries(test_ukf ros_filter ukf ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_interfaces
                    test/test_ukf_localization_node_interfaces.test
                    test/test_ukf_localization_node_interfaces.cpp)
  target_link_libraries(test_ukf_localization_node_interfaces ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_bag1
                    test/test_ukf_localization_node_bag1.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_node_bag1 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_bag2
                    test/test_ukf_localization_node_bag2.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_node_bag2 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

  add_rostest_gtest(test_ukf_localization_node_bag3
                    test/test_ukf_localization_node_bag3.test
                    test/test_localization_node_bag_pose_tester.cpp)
  target_link_libraries(test_ukf_localization_node_bag3 ${catkin_LIBRARIES} ${rostest_LIBRARIES})

endif()

=== debian/changelog ===
ros-indigo-robot-localization (2.3.4-0trusty) trusty; urgency=high

  * Fixing issue with potential seg fault
  * Contributors: Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Tue, 10 Apr 2018 23:00:00 -0000

ros-indigo-robot-localization (2.3.3-0trusty) trusty; urgency=high

  * Zero out rotation in GPS to base_link transform
  * Fix typo in reading Mahalanobis thresholds.
  * Fixing state history reversion
  * Some trivial changes to lessen the differences to lunar
  * Fixing critical bug with dynamic process noise covariance
  * Fixing datum precision
  * Contributors: Jacob Seibert, Pavlo Kolomiiets, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Fri, 15 Dec 2017 00:00:00 -0000

ros-indigo-robot-localization (2.3.2-0trusty) trusty; urgency=high

  * Updated documentation
  * Added reset_on_time_jump option
  * Added feature to optionally publish utm frame as parent in navsat_transform_node
  * Moved global callback queue reset
  * Added initial_state parameter and documentation
  * Fixed ac/deceleration gains default logic
  * Added gravity parameter
  * Added delay and throttle if tf lookup fails
  * Fixed UKF IMUTwistBasicIO test
  * Added transform_timeout parameter
  * Set gps_odom timestamp before tf2 lookuptransform
  * Removed non-portable sincos calls
  * Simplified logic to account for correlated error
  * Added dynamic process noise covariance calculation
  * Fixed catkin_package Eigen warning
  * Added optional publication of acceleration state
  * Contributors: Brian Gerkey, Enrique Fernandez, Jochen Sprickerhof, Rein Appeldoorn, Simon Gene Gottlieb, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Mon, 05 Jun 2017 23:00:00 -0000

ros-indigo-robot-localization (2.3.1-0trusty) trusty; urgency=high

  * Adding gitignore
  * Adding remaining wiki pages
  * Adding config and prep pages
  * Adding navsat_transform_node documentation
  * use_odometry_yaw fix for n_t_n
  * Fixing issue with manual pose reset when history is not empty
  * Getting inverse transform when looking up robot's pose.
  * Sphinx documentation
  * Removing forward slashes from navsat_transform input topics for template launch file
  * Adding example launch and parameter files for a two-level EKF setup with navsat_transform_node
  * Adding yaml file for navsat_transform_node, and moving parameter documentation to it.
  * Updating EKF and UKF parameter templates with usage comments
  * Contributors: Tom Moore, asimay

 -- Tom Moore <ayrton04@gmail.com>  Wed, 26 Oct 2016 23:00:00 -0000

ros-indigo-robot-localization (2.3.0-0trusty) trusty; urgency=high

  * Fixed issues with datum usage and frame_ids
  * Fixed comment for wait_for_datum
  * Fixing issue with non-zero navsat sensor orientation offsets
  * Fixing issue with base_link->gps transform wrecking the 'true' UTM position computation
  * Using correct covariance for filtered GPS
  * Fixed unitialized odometry covariance bug
  * Added filter history and measurement queue behavior
  * Changing output timestamp to more accurately use the time stamp of the most recently-processed measurement
  * Added TcpNoDelay()
  * Added parameter to make transform publishing optional
  * Fixed differential handling for pose data so that it doesn't care about the message's frame_id
  * Updated UKF config and launch
  * Added a test case for the timestamp diagnostics
  * Added reporting of bad timestamps via diagnostics
  * Updated tests to match new method signatures
  * Added control term
  * Added smoothing capability for delayed measurements
  * Making variables in navsat_transform conform to ROS coding standards
  * Contributors: Adel Fakih, Ivor Wanders, Marc Essinger, Tobias Tueylue, Tom Moore

 -- Tom Moore <ayrton04@gmail.com>  Wed, 27 Jul 2016 23:00:00 -0000

ros-indigo-robot-localization (2.2.3-0trusty) trusty; urgency=high

  * Cleaning up callback data structure and callbacks and updating doxygen comments in headers
  * Removing MessageFilters
  * Removing deprecated parameters
  * Adding the ability to handle GPS offsets from the vehicle's origin
  * Cleaning up navsat_transform.h
  * Making variables in navsat_transform conform to ROS coding standards

 -- Tom Moore <ayrton04@gmail.com>  Sat, 23 Apr 2016 23:00:00 -0000

ros-indigo-robot-localization (2.2.2-0trusty) trusty; urgency=high

  * Updating trig functions to use sincos for efficiency
  * Updating licensing information and adding Eigen MPL-only flag
  * Added state to imu frame transformation
  * Using state orientation if imu orientation is missing
  * Manually adding second spin for odometry and IMU data that is passed to message filters
  * Reducing delay between measurement reception and filter output
  * Zero altitute in intital transform too, when zero altitude param is set
  * Fixing regression with conversion back to GPS coordinates
  * Switched cropping of orientation data in inovationSubset with mahalanobis check to prevent excluding measurements with orientations bigger/smaller than ± PI
  * Fix Jacobian for EKF.
  * Removing warning about orientation variables when only their velocities are measured
  * Checking for -1 in IMU covariances and ignoring relevant message data
  * roslint and catkin_lint applied
  * Adding base_link to datum specification, and fixing bug with order of measurement handling when a datum is specified. Also added check to make sure IMU data is transformable before using it.
  * Contributors: Adnan Ademovic, Jit Ray Chowdhury, Philipp Tscholl, Tom Moore, ayrton04, kphil

 -- Tom Moore <ayrton04@gmail.com>  Thu, 04 Feb 2016 00:00:00 -0000

ros-indigo-robot-localization (2.2.1-0trusty) trusty; urgency=high

  * Fixed handling of IMU data w.r.t. differential mode and relative mode

 -- Tom Moore <tmoore@cra.com>  Tue, 26 May 2015 23:00:00 -0000

ros-indigo-robot-localization (2.2.0-0trusty) trusty; urgency=high

  * Added tf2-friendly tf_prefix appending
  * Corrected for IMU orientation in navsat_transform


=== debian/control ===
Source: ros-indigo-robot-localization
Section: misc
Priority: extra
Maintainer: Tom Moore <ayrton04@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libeigen3-dev, python-catkin-pkg, ros-indigo-catkin, ros-indigo-cmake-modules, ros-indigo-diagnostic-msgs, ros-indigo-diagnostic-updater, ros-indigo-geographic-msgs, ros-indigo-geometry-msgs, ros-indigo-message-filters, ros-indigo-message-generation, ros-indigo-nav-msgs, ros-indigo-rosbag, ros-indigo-roscpp, ros-indigo-roslint, ros-indigo-rostest, ros-indigo-rosunit, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf2, ros-indigo-tf2-geometry-msgs, ros-indigo-tf2-ros
Homepage: http://ros.org/wiki/robot_localization
Standards-Version: 3.9.2

Package: ros-indigo-robot-localization
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libeigen3-dev, ros-indigo-cmake-modules, ros-indigo-diagnostic-msgs, ros-indigo-diagnostic-updater, ros-indigo-geographic-msgs, ros-indigo-geometry-msgs, ros-indigo-message-filters, ros-indigo-message-runtime, ros-indigo-nav-msgs, ros-indigo-roscpp, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-tf2, ros-indigo-tf2-geometry-msgs, ros-indigo-tf2-ros
Description: Provides nonlinear state estimation through sensor fusion of an abritrary number of sensors.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/indigo/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG -O3

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/indigo" \
		-DCMAKE_PREFIX_PATH="/opt/ros/indigo"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-indigo-robot-localization//opt/ros/indigo/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/indigo/setup.sh" ]; then . "/opt/ros/indigo/setup.sh"; fi && \
	dh_auto_install
